;-------------------------------;
;      Men vzdlenosti	;
;	 distann rel		;
;-------------------------------;
;)S(2018.04	  slovak@post.cz;
;-------------------------------;
;Senzor: HC-SR04		;
;rozsah: 2 a 400cm		;
;rozlien: 1cm			;
;-------------------------------;
;Vstupy:			;
;VB4  svorka L1			;
;VA1  svorka L2			;
;-------------------------------;
;LED displej:
;3 msta, spolen anody.
;
;Tlatka:
;Set(S) lev, mnus(-) stedn, plus(+) prav.
;
;Menu: (+)(-) Vbr poloky, (S) ukzat nadpis prv zobrazovan hodnoty (po dobu dren tlatka)
;nadpis	hodnota
;cm	V	vzdlenost (2 a 400, rozlien 1cm)
;H.M.1	HM1	horn mez 1 (2 a 400, krok 1)
;d.M.1	DM1	doln mez 1 (2 a 400, krok 1)
;H.M.2	HM2	horn mez 2 (2 a 400, krok 1)
;d.M.2	DM2	doln mez 2 (2 a 400, krok 1)
;ru.P.	r.xx	run provoz, run ovldn vstup (1=zap, 0=vyp, prostedn znak:VB4, vpravo:VA1)
;
;Po neinnosti tlatek (17s) se Menu automaticky vrt na 1.poloku cm.
; Automatick nvrat neplat pi nastavovn (displej blik).
;
;Nastavovn:
;(+)(-) nalistovat poadovanou poloku
;(S)	dret, dokud displej nezane blikat
;(+)(-) zmnit +/- (dlouh stisk, rychl pitn/odetn)
;(S)	uloit
;--------------------------------
;Podmnky ovldn vstup (1=ZAP, 0=VYP)
;
;VB4=0 pi V >= HM1
;VB4=1 pi V <= DM1
;
;VA1=1 pi V >= HM2
;VA1=0 pi V <= DM2
;--------------------------------
;Mikroprocesor PIC16F1847 (16F1827)
;
;RB7 Katoda f
;RB6 Katoda a
;RB5 Anoda A1 (znak vlevo)
;RB4 vstup VB4 (CON1-B4-L1)
;RB3 idlo HC-SR04, svorka DS (IN)
;RB2 Katoda e, TlS (S) vlevo
;RB1 Katoda d, TlM (-) uprosted
;RB0 Katoda T, TlP (+) vpravo
;
;RA7 Anoda A3 (znak vpravo)
;RA6 Anoda A2 (znak stedn)
;RA5 vstup (nevyuito) (CON1-A5)
;RA4 Katoda g
;RA3 vstup VA3 (CON1-A3)
;RA2 Katoda c
;RA1 vstup VA1 (CON1-A1-L2)
;RA0 Katoda b
;--------------------------------
;Pipojen senzoru HC-SR04
;____
;|()|-Gnd--------------------- GND
;|  |-Echo-------------------- IN RB3
;|  |-Trig-samoblikajc LED
;|()|-Vcc--------------------- +5V
;
;--------------------------------

 LIST P=16F1847, R=DEC, MM=ON	;Direktivy pekladae
 include<p16f1847.inc>		;Definice nzv registr

;Nastaven konfigurace procesoru:
 __CONFIG _CONFIG1,_CP_OFF & _CPD_OFF & _WDTE_ON & _MCLRE_OFF & _FOSC_INTOSC & _CLKOUTEN_OFF & _PWRTE_ON & _BOREN_ON & _IESO_OFF & _FCMEN_OFF
 __CONFIG _CONFIG2,_WRT_OFF & _LVP_ON & _BORV_LO & _STVREN_OFF & _PLLEN_OFF

 errorlevel 1, -306

 cblock	0x20
A1,A2,A3	;matematick promnn
B1,B2,B3	; (a jin funkce)
C1,C2,C3	;
D1,D2,D3	;
X1,X2		;
FL		;Flag, pznaky
	 ;EEPROM
HM11,HM12;00	;HM1 horn mez1 pro ZAP VB4 L1 (RE1)
DM11,DM12;02	;DM1 doln mez1 pro VYP VB4 L1 (RE1)
HM21,HM22;04	;HM2 horn mez2 pro ZAP VA1 L2 (RE2)
DM21,DM22;06	;DM2 doln mez2 pro VYP VA1 L2 (RE2)
K1,K2	 ;08	;konstanta pro vpoet vzdlenosti (23027)

AV1,AV2		;aktuln vzdlenost, na displeji (doln/horn bajt)
NV1,NV2		;nov vzdlenost, namen
MV1,MV2		;minul vzdlenost, porovnvac

DIS		;poad, 0=Znak1 (vlevo), 1=Znak2 (uprosted), 2=Znak3 (vpravo)
Znak1		;slo zobrazovanho znaku, nap. 10=A
Znak2		;
Znak3		;
BLIK		;blikn pi nastavovn
KLVP		;port klvesnice, bit 0:P, 1:M, 2:S (stisknuto=Log.0)
KLVD		;dli ten klvesnice
KLVO		;dli opakovn tlatka
R1,R2,R3,R4	;vstup pevodu HEX/DEC, desetiny, jedniky, destky, stovky
DN		;dli nvrat na zobrazen teploty
 endc

EEADRp	EQU	0x7F	;pomocn EE adresa

#define	SC	STATUS,C
#define	SZ	STATUS,Z

#define	Znam	FL,7	;znamnko, 1=zporn hodnota
#define	Azn	FL,6	;znamnka pro Mat. vpoty
#define	Bzn	FL,5	;
#define	Stisk	FL,4	;minule stisknuto
#define	Znova	FL,3	;znova stisknuto
#define	VD	FL,2	;1=vpoet dokonen, men vzdlenosti

#define	TlS	KLVP,2	;tlatko (S) Set
#define	TlM	KLVP,1	;tlatko (-) Mnus
#define	TlP	KLVP,0	;tlatko (+) Plus

#define	VB4	LATB,4	;vstup B4 (L1)
#define VA1	LATA,1	;vstup A1 (L2)
#define VA3	LATA,3	;vstup A3 (nepouito)

;slo znaku (nap. zobrazen A s tekou: MOVLW zA+.)
#define	.	128	;teka
#define	zA	10	;znak A
#define	zb	11
#define	zC	12
#define	zd	13
#define zE	14
#define	zF	15
#define	zG	16
#define	zH	17
#define	zi	18
#define	zJ	19
#define	zk	20
#define	zL	21
#define	zM	22
#define zn	23
#define	zo	24
#define	zP	25
#define	zr	26
#define	zS	27	;(segment a,c,f,g)
#define	zt	28
#define	zu	29
#define	zV	30
#define	zY	31
#define	sp	32	;space
#define	zm1	33	;-1 (segment b,c,g)
#define	zhm	34	;(segment a)
#define	zmi	35	;-
#define	z_	36	;znak podtrtko (segment d)
#define	zro	37	;= (segment d,g)
#define	z3m	38	;3x - (segment a,d,g)
#define	zst	39	;
#define	zc	40
#define	zpz	41	;)
#define	zII	42	;(segment b,c,e,f)

;*************************************************

	ORG	0xF000	;data v EEPROM

 de 0x19, 0x00, 0x14, 0x00, 0x69, 0x00, 0x64, 0x00
 de 0xF3, 0x59, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
 de 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
 de 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
 de 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
 de 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
 de 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
 de 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
 de 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
 de 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
 de 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
 de 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
 de 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
 de 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
 de 0x29, 0x53, 0x28, 0x32, 0x30, 0x31, 0x38, 0x2E
 de 0x30, 0x34, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF

;********************************
;reset
 	ORG	0
	GOTO	Init
	CALL	41
	CALL	83
	CALL	40

;IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
;peruen
;--------------------------------
;od RB,3 nebo TMR0 ?
	BTFSS	INTCON,IOCIF	;=1?
	BRA	I_TMR0		;NE

;================================
;peruen od RB,3
	BCF	INTCON,IOCIF	;nulovat pznak
	MOVLB	7
	CLRF	IOCBF		;nulovat pznak
	MOVLB	0

;vzestupn hrana
	BTFSS	PORTB,3		;=1?
	BRA	RB3L		;NE

	BSF	T1CON,TMR1ON	;start TMR1
	RETFIE			;konec peruen

;sestupn hrana
RB3L	BCF	T1CON,TMR1ON	;stop TMR1
	BCF	VD		;vpoet dokonen =0, nov vpoet
	RETFIE			;konec peruen

;================================
;peruen od TMR0 244Hz (4MHz/4/16/256)
I_TMR0	MOVLB	0
	BCF	INTCON,TMR0IF	;nulovat pznak

;DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD
;Displej, multiplex
	MOVF	DIS,W		;displej poad (0=Anoda1, 1=Anoda2, 2=Anoda3)
	ADDLW	Znak1		; + RAM adresa prvnho znaku
	MOVWF	FSR0L		;do ukazovtka
;Zhasnout displej
	MOVLB	2
	BCF	LATB,5		;VYP Anoda 1
	MOVLW	B'00101010'
	ANDWF	LATA,F		;VYP Anody 2,3; VYP Katody g,c,b
	MOVLW	B'00011000'
	ANDWF	LATB,F		;VYP Katody f,a,e,d,T
	MOVLB	0

;GGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGG
;genertor 15Hz (244/16)
	DECFSZ	KLVD,F		;-1=0?
	BRA	ENDG15
	MOVLW	16		;znovu
	MOVWF	KLVD		; naplnit

;TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
;ten tlatek
	MOVLW	B'00000111'	;1=vstup
	MOVLB	1
	IORWF	TRISB		;pepnut portu na vstup
	MOVLB	0

;=====vloen dlie (15Hz)=====;
;dli pro nvrat na 1.displej
	MOVF	DN,F
	BTFSS	SZ		;DN=0?
	DECF	DN,F		;NE, -1
;===============================;
;pokraovn ten tlatek
;	MOVF	PORTB,W		;zotaven portu po pepnut na vstup (6 stroj. cykl)
;	MOVF	PORTB,W		; (ve vloen dlie zastupuj tcto 6 dk)
;	MOVF	PORTB,W		;
	MOVF	PORTB,W		;
	MOVF	PORTB,W		;
	MOVF	PORTB,W		;
	MOVF	PORTB,W		;ten portu
	ANDLW	B'00000111'	;(1a1=1)
	MOVWF	KLVP		;uloit
	MOVLB	1
	MOVLW	B'11111000'	;0=vstup
	ANDWF	TRISB,F		;(1a1=1)
	MOVLB	0
	BRA	ZAPK

;--------------------------------
;konec genertoru 15Hz
ENDG15
;nhrada za ten tlatek (20 cykl)
	MOVLW	6
	DECFSZ	WREG,F		;-1,=0?
	BRA	$-1		;NE
	BRA	$+1

;--------------------------------
;zapnout Katody podle DIS v ukazovtku FSR (0=Znak1, 1=Znak2, 2=Znak3)
ZAPK	MOVLB	2
	CALL	Segment
	ANDLW	B'11000110'	;(1a1=1) pouze Katody pro PB (f,a,e,d,T)
	BTFSS	INDF0,7		;znak s tekou? (teka pslunho znaku svt pokud bit7=1)
	ADDLW	1		;NE, VYP teku
	IORWF	LATB,F		;(0a0=0) nastavit Katody f,a,e,d,T
	CALL	Segment
	ANDLW	B'00011001'	;(1a1=1) pouze Katody pro PA (g,c,b)
;segment c pesunout z bitu3 na bit2 (0->bit3->bit2)
	BTFSC	WREG,3		;segment c=1?
	BSF	WREG,2		;ANO, bit2=1
	BCF	WREG,3		;bit3=0
	IORWF	LATA,F		;(0a0=0) nastavit Katody g,c,b
;rozsvtit displej, zapnout Anodu podle DIS (0:A1, 1:A2, 2:A3)
	CALL	Anoda
	IORWF	LATA,F		;(0a0=0) A2 nebo A3 na PA
	ANDLW	B'00100000'	;(1a1=1)
	IORWF	LATB,F		;(0a0=0) nebo A1 na PB
	MOVLB	0
;dal displej (pt Anoda)
	INCF	DIS,F		;+1
	MOVF	DIS,W
	SUBLW	2		;2-DIS
	BTFSS	SC		;zporn?
	CLRF	DIS		;ANO, nulovat

;=========dlie 244Hz==========;
;dli opakovn KLV
	DECF	KLVO,F		;-1
	BTFSC	SZ		;KLVO=0?
	BSF	Znova		;NE, Znova=1
;dli blikn displeje pi nastavovn
	INCF	BLIK,F		;+1

;--------------------------------
;konec peruen
	RETFIE

;********************************
;pevede slo znaku na sedmisegment
Segment	MOVF	INDF0,W		;slo znaku, FSR ukazuje na Znak(1,2,3)
	ANDLW	B'01111111'	;odebrat bit 7 pro teku, zde se nevyhodnocuje
	SUBLW	45		;41-W (MAX slo znaku)
	MOVF	INDF0,W		;obnovit slo znaku
	ANDLW	B'01111111'	;
	BTFSS	SC		;zporn? (odeet 41-W)
	MOVLW	36		;ANO, nahradit znak

	BRW			;W+PC
;Segmenty(0=svt)fa_gcedb
	RETLW	B'00110000'	;0/0
	RETLW	B'11110110'	;1/1
	RETLW	B'10101000'	;2/2
	RETLW	B'10100100'	;3/3
	RETLW	B'01100110'	;4/4
	RETLW	B'00100101'	;5/5
	RETLW	B'00100001'	;6/6
	RETLW	B'10110110'	;7/7
	RETLW	B'00100000'	;8/8
	RETLW	B'00100100'	;9/9
	RETLW	B'00100010'	;10/A
	RETLW	B'01100001'	;11/b
	RETLW	B'00111001'	;12/C
	RETLW	B'11100000'	;13/d
	RETLW	B'00101001'	;14/E
	RETLW	B'00101011'	;15/F
	RETLW	B'00110001'	;16/G
	RETLW	B'01100010'	;17/H
	RETLW	B'11111011'	;18/i
	RETLW	B'11110000'	;19/J
	RETLW	B'01101011'	;20/k
	RETLW	B'01111001'	;21/L
	RETLW	B'00110010'	;22/M
	RETLW	B'11100011'	;23/n
	RETLW	B'11100001'	;24/o
	RETLW	B'00101010'	;25/P
	RETLW	B'11101011'	;26/r
	RETLW	B'00100111'	;27/S
	RETLW	B'01101001'	;28/t
	RETLW	B'11110001'	;29/u
	RETLW	B'01110000'	;30/V
	RETLW	B'01100100'	;31/Y
	RETLW	B'11111111'	;32/ (zhasnuto)
	RETLW	B'11100110'	;33/-1
	RETLW	B'10111111'	;34/ (segment a)
	RETLW	B'11101111'	;35/-
	RETLW	B'11111101'	;36/_
	RETLW	B'11101101'	;37/=
	RETLW	B'10101101'	;38/ (segment a,d,g)
	RETLW	B'00101110'	;39/
	RETLW	B'11101001'	;40/c
	RETLW	B'10110100'	;41/)
	RETLW	B'01110010'	;42/II
	RETLW	B'11100111'	;43/ (segment c,g)
	RETLW	B'11111101'	;44/_
	RETLW	B'11111101'	;45/_

;--------------------------------
;vybere Anodu (1=svt)
Anoda	MOVLB	0
	MOVF	DIS,W
	MOVLB	2
	ANDLW	B'00000011'
	BRW			;W+PC
	RETLW	B'00100000'	;DIS=0, Znak1, A1, vlevo
	RETLW	B'01000000'	;DIS=1, Znak2, A2, sted
	RETLW	B'10000000'	;DIS=2, Znak3, A3, vpravo
	RETLW	B'00100000'

;-------------------------------;
;   Matematicke podprogramy	;
;-------------------------------;
;slovak@post.cz	      )S(12.2004;
;-------------------------------;
; A1,2,3 / B1,2,3 = C1,2,3
;24Bit, pouze kladna cisla
;SZ=1=deleni nulou (B1,2,3=0)
;B se nezmeni, v A bude zbytek
;pouziva D1,2,3; X1
LOMENO24
;test B na nulu; sZ=1=ANO
;	MOVF	B1,F
;	BTFSC	STATUS,Z	;nenulove?
;	MOVF	B2,F
;	BTFSC	STATUS,Z	;nenulove?
;	MOVF	B3,F
;	BTFSC	STATUS,Z	;nenulove?
;	RETURN			;B1,2,3=0
;priprava pro deleni
LOM24	MOVF	A1,W		;A do D
	MOVWF	D1		;
	MOVF	A2,W		;
	MOVWF	D2		;
	MOVF	A3,W		;
	MOVWF	D3		;
	CLRF	A1		;nulovat
	CLRF	A2		;
	CLRF	A3		;
	MOVLW	24		;pocet bitu
	MOVWF	X1		;
	BCF	STATUS,C	;SC=0
;deleni
LDalsi	CALL	x2M		;D,A posun vlevo, A-B=C
	BTFSS	STATUS,C	;kladny vysledek?
	BRA	LZapor		;NE
;LKlad
	MOVWF	A3		;C do A
	MOVF	C2,W		;
	MOVWF	A2		;
	MOVF	C1,W		;
	MOVWF	A1		;

LZapor	DECFSZ	X1,F		;-1=0?
	BRA	LDalsi		;jeste neni konec
;vysledek
	RLF	D1,W		;posledni x2
	MOVWF	C1		; a W do C
	RLF	D2,W		;
	MOVWF	C2		;
	RLF	D3,W		;
	MOVWF	C3		;

	BCF	STATUS,Z	;SZ=0
	RETURN

;--------------------------------
; A1,2,3 / B1,2,3 = C1,2,3
;23Bit; MSB=0=kladne, 1=zaporne
;SZ=1=deleni nulou (B1,2,3=0)
;B se nezmeni, v A bude zbytek
;pouziva D1,2,3; X1; FL,Azn,Bzn
;LOMENO
;test B na nulu; SZ=1=ANO
;	MOVF	B1,F
;	BTFSC	STATUS,Z	;nenulove?
;	MOVF	B2,F
;	BTFSC	STATUS,Z	;nenulove?
;	MOVF	B3,F
;	BTFSC	STATUS,Z	;nenulove?
;	RETURN			;B1,2,3=0
;test A=zaporne
;	BCF	Azn		;=0
;	BTFSC	A3,7		;MSB=1?
;	CALL	ZZA		;zmena znamenka A1,2,3
;test B=zaporne
;	BCF	Bzn		;=0
;	BTFSC	B3,7		;MSB=0?
;	CALL	ZZB		;zmena znamenka B1,2,3
;vypocet
;	CALL	LOM24
;vratit B
;	BTFSC	Bzn		;=0?
;	CALL	ZZB
;znamenko C, test Azn = Bzn
;	BTFSC	Azn		;=0?
;	BRA	$+4		;NE
;	BTFSC	Bzn		;=0?
;	BRA	$+3		;NE
;	BRA	$+3		;Azn = Bzn = 0
;	BTFSS	Bzn		;=1?
;	CALL	ZZC		;NE, zmena znamenka C1,2,3
;
;	BCF	STATUS,Z	;SZ=0
;	RETURN
;
;................................
; D1,2,3 A1,2,3 * 2 a Minus
x2M	RLF	D1,F		;posuv vlevo
	RLF	D2,F		;
	RLF	D3,F		;
	RLF	A1,F		;
	RLF	A2,F		;
	RLF	A3,F		;
				;pokracuje MINUS
;--------------------------------
; A1,2,3 - B1,2,3 = C1,2,3
;SC=0=zaporny vysledek
;A,B se nezmeni
MINUS	MOVF	B1,W
	SUBWF	A1,W		;A1-B1
	MOVWF	C1		;=C1
	MOVF	B2,W
	SUBWFB	A2,W		;A2-B2-SC
	MOVWF	C2		;=C2
	MOVF	B3,W
	SUBWFB	A3,W		;A3-B3-SC
	MOVWF	C3		;=C3
	RETURN

;--------------------------------
; A1,2,3 + C1,2,3 = C1,2,3
;A se nemeni
;PLUS	MOVF	A1,W
;	ADDWF	C1,F		;A1+C1=C1
;	MOVF	A2,W
;	ADDWFC	C2,F		;A2+C2=C2
;	MOVF	A3,W
;	ADDWFC	C3,F		;A3+C3=C3
;	RETURN
;
;--------------------------------
; A1,2,3 * B1,2,3 = C1,2,3
;24Bit, pouze kladna cisla
;A, B se nezmeni
;pouziva D1,2,3; X1; X2
;KRAT24
;schovat A do D
;	MOVF	A1,W		;A do D
;	MOVWF	D1		;
;	MOVF	A2,W		;
;	MOVWF	D2		;
;	MOVF	A3,W		;
;	MOVWF	D3		;
;priprava
;	CLRF	C1		;nulovat
;	CLRF	C2		;
;	CLRF	C3		;
;	BCF	STATUS,C	;
;	MOVLW	25		;pocet bitu+1
;	MOVWF	X1		;
;hledat jednicku
;	RRF	B3,F		;posuv vpravo
;	RRF	B2,F		;
;	RRF	B1,F		;
;	MOVF	STATUS,W	;ulozit
;	MOVWF	X2		; SC
;	BTFSC	STATUS,C	;=0?
;A+C=C
;	CALL	PLUS		;jen pri SC=1
;A*2
;	RLF	A1,F		;posuv vlevo
;	RLF	A2,F		;
;	RLF	A3,F		;
;
;	MOVF	X2,W		;obnovit
;	MOVWF	STATUS		; SC
;
;	DECFSZ	X1,F		;-1=0?
;	BRA	$-13		;NE
;obnovit A z D
;	MOVF	D1,W		;D do A
;	MOVWF	A1		;
;	MOVF	D2,W		;
;	MOVWF	A2		;
;	MOVF	D3,W		;
;	MOVWF	A3		;
;	RETURN		
;
;--------------------------------
; A1,2,3 * B1,2,3 = C1,2,3
;23Bit, MSB=0=kladne, 1=zaporne
;A, B se nezmeni
;pouziva D1,2,3; X1; X2
;KRAT
;test A=zaporne
;	BCF	Azn
;	BTFSC	A3,7		;=0?
;	CALL	ZZA		;zmena znamenka A
;test B=zaporne
;	BCF	Bzn
;	BTFSC	B3,7		;=0?
;	CALL	ZZB		;zmena znamenka B
;vypocet
;	CALL	KRAT24		;A*B=C
;znamenko A
;	BTFSC	Azn		;=0?
;	CALL	ZZA
;znamenko B
;	BTFSC	Bzn		;=0?
;	CALL	ZZB
;znamenko C, test Azn = Bzn
;	BTFSC	Azn		;=0?
;	BRA	$+4		;NE
;	BTFSC	Bzn		;=0?
;	BRA	$+3		;NE
;	BRA	$+3		;Azn = Bzn = 0
;	BTFSS	Bzn		;=1?
;	CALL	ZZC		;NE, zmena znamenka C1,2,3
;
;	BCF	STATUS,Z	;SZ=0
;	RETURN
;
;--------------------------------
;zmena znamenka A1,2,3
;ZZA	BSF	Azn		;=1
;	COMF	A1,F
;	COMF	A2,F
;	COMF	A3,F
;	INCFSZ	A1,F		;+1,=0?
;	RETURN
;	INCFSZ	A2,F		;+1,=0?
;	RETURN
;	INCF	A3,F		;+1
;	RETURN
;
;--------------------------------
;zmena znamenka B1,2,3
;ZZB	BSF	Bzn		;=1
;	COMF	B1,F
;	COMF	B2,F
;	COMF	B3,F
;	INCFSZ	B1,F		;+1,=0?
;	RETURN
;	INCFSZ	B2,F		;+1,=0?
;	RETURN
;	INCF	B3,F		;+1
;	RETURN
;
;--------------------------------
;zmena znamenka C1,2,3
;ZZC	COMF	C1,F
;	COMF	C2,F
;	COMF	C3,F
;	INCFSZ	C1,F		;+1,=0?
;	RETURN
;	INCFSZ	C2,F		;+1,=0?
;	RETURN
;	INCF	C3,F		;+1
;	RETURN
;
;--------------------------------
;test C=0; SZ=1=ANO
;TC0	MOVF	C3,F
;	BTFSC	STATUS,Z	;nenulove?
;	MOVF	C2,F
;	BTFSC	STATUS,Z	;nenulove?
;	MOVF	C1,F
;	RETURN
;
;--------------------------------
;nsoben konstantou 8192
;pro posunut desetin rky
; A1,2 * 8192 = A1,2,3
;x8192	SWAPF	A2,W
;	ANDLW	0xF0
;	MOVWF	A3
;	SWAPF	A1,W
;	ANDLW	0x0F
;	IORWF	A3,F
;	SWAPF	A1,W
;	ANDLW	0xF0
;	MOVWF	A2
;	CLRF	A1
;	BCF	STATUS,C
;	RLF	A2,F
;	RLF	A3,F
;	RETURN

;--------------------------------
; B1,2 = B1,2 * 2^W
;x2W	MOVWF	C1		;kolikrt
;	BCF	SC
;	RLF	B1,F		;<-SC
;	RLF	B2,F		;
;	DECFSZ	C1,F		;-1=0?
;	BRA	$-4		;znova
;A1,2 = A1,2 + B1,2
;	MOVF	B1,W
;	ADDWF	A1,F		;B1+A1=A1
;	BTFSC	SC		;nepeteklo?
;	INCF	A2,F		;ANO, +1
;	MOVF	B2,W
;	ADDWF	A2,F		;B2+A2=A2
;	RETURN
;
;--------------------------------
; B1,2 = B1,2 * 2
;Bx2
;	LSLF	B1,F
;	RLF	B2,F
;	MOVF	B1,W
;	RETURN

;MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
;mez mnus, A1,2 = A1,2 - 1 (MIN=2, MAX=400)
MEZM
;test, MEZ=2?
	MOVF	A2,F
	BTFSS	SZ		;A2=0?
	BRA	MEZM1		;NE
	MOVF	A1,W
	SUBLW	2		;2-A1
	BTFSS	SC		;zporn?
	BRA	MEZM1		;ANO	
;nastavit 400 (190h)
	MOVLW	1
	MOVWF	A2
	MOVLW	0x90
	MOVWF	A1
	RETURN
MEZM1
	MOVLW	1
	SUBWF	A1,F
	CLRW
	SUBWFB	A2,F
	RETURN

;--------------------------------
;mez plus, A1,2 = A1,2 + 1 (MIN=2, MAX=400)
MEZP
;test, MEZ=400? (190h)
	MOVLW	1
	SUBWF	A2,W		;A1-1
	BTFSS	SC		;zporn?
	BRA	MEZP1		;ANO
	MOVLW	0x90
	SUBWF	A1,W		;A2-90h
	BTFSS	SC		;zporn?
	BRA	MEZP1		;ANO
;nastavit 2
	MOVLW	2
	MOVWF	A1
	CLRF	A2
	RETURN
MEZP1
	INCFSZ	A1,F
	RETURN
	INCF	A2,F
	RETURN

;MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
;men vzdlenosti
MV	BTFSS	T1CON,TMR1ON	;asova TMR1 b?
	BRA	VV		;NE

	BTFSS	PIR1,TMR1IF	;asova TMR1 petekl?
	RETURN			;NE
;asova TMR1 petekl
	BCF	T1CON,TMR1ON	;stop TMR1
	BCF	PIR1,TMR1IF	;nulovat pznak
	CLRF	TMR1L		;nulovat asova
	CLRF	TMR1H		;
	BSF	VD		;nastavit vpoet dokonen
	RETURN
;VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
;vpoet vzdlenosti (TMR1*256/K)
VV	BTFSC	VD		;vpoet dokonen?
	RETURN			;ANO

;A1,2,3 = TMR1 x 256
	MOVF	TMR1H,W
	MOVWF	A3
	MOVF	TMR1L,W
	MOVWF	A2
	CLRF	A1
	CLRF	TMR1L		;nulovat asova
	CLRF	TMR1H		;
;konstanta do B1,2,3 (zkladn=23027=59F3h; reln=28912=70F0h)
	CLRF	B3
;	MOVLW	0x70
	MOVF	K2,W		;konstanta, horn bajt
	MOVWF	B2
;	MOVLW	0xF0
	MOVF	K1,W		;konstanta, doln bajt
	MOVWF	B1
;A1,2,3 / B1,2,3 = C1,2,3
	CALL	LOMENO24
;uloit vsledek
	MOVF	C1,W
	MOVWF	NV1
	MOVF	C2,W
	MOVWF	NV2

	BSF	VD		;vpoet dokonen

;FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F1	;filtr F1
;kdy je Nov > Aktuln, tak Aktuln +1
;test NV>AV
	MOVF	NV1,W		;NV do A
	MOVWF	A1		;
	MOVF	NV2,W		;
	MOVWF	A2		;
	MOVF	AV1,W		;V do B
	MOVWF	B1		;
	MOVF	AV2,W		;
	MOVWF	B2		;
	CALL	PAB		;A > B   SC=1
	BTFSS	SC		;ANO?
	BRA	$+5		;NE
;AV+1
	INCFSZ	AV1,F		;+1=0?
	BRA	F2		;NE
	INCF	AV2,F		;+1
	BRA	F2

;kdy je Nov < Aktuln, tak Aktuln -1
;test NV<AV
	MOVF	NV1,W		;NV do B
	MOVWF	B1		;
	MOVF	NV2,W		;
	MOVWF	B2		;
	MOVF	AV1,W		;V do A
	MOVWF	A1		;
	MOVF	AV2,W		;
	MOVWF	A2		;
	CALL	PAB		;B < A   SC=1
	BTFSS	SC		;ANO?
	BRA	NVMV		;NE
;AV-1
	DECF	AV1,F		;-1
	INCFSZ	AV1,W		;+1=0?
	BRA	F2		;NE
	DECF	AV2,F		;-1

;--------------------------------
F2	;filtr F2
;kdy je Nov stejn jako Minul, tak Nov do Atuln, v opanm ppad Nov do Minul
;test NV=MV
	MOVF	NV1,W
	XORWF	MV1,W
	BTFSS	SZ		;stejn?
	BRA	NVMV		;NE
	MOVF	NV2,W
	XORWF	MV2,W
	BTFSS	SZ		;stejn?
	BRA	NVMV		;NE
;stejn, Nov do Atuln
	MOVF	NV1,W
	MOVWF	AV1
	MOVF	NV2,W
	MOVWF	AV2
;Nov do Minul
NVMV	MOVF	NV1,W	
	MOVWF	MV1
	MOVF	NV2,W	
	MOVWF	MV2

;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;	RETURN
	GOTO	OV		;ovldn vstup

;--------------------------------
;VYP displej
VYPD	MOVLW	sp		;VYP
	MOVWF	Znak1		;
	MOVWF	Znak2		;
	MOVWF	Znak3		; displej
	RETURN

;HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
;pevod HEX/DEC, vstup A1,2, vstup R1,2,3,4
HEXDEC
;upravit zporn slo
	BCF	Znam		;=0
	BTFSS	A2,7		;=1?
	BRA	PHD
	BSF	Znam		;=1, zporn
;zmna znamnka A1,2
	COMF	A2,F
	COMF	A1,F
	INCFSZ	A1,F		;+1=0?
	BRA	PHD
	INCF	A2,F		;+1
;pevod
PHD	CLRF	A3
	MOVLW	0xE8		;1000 do B
	MOVWF	B1		;
	MOVLW	0x03		;
	MOVWF	B2		;
	CLRF	B3		;
	CALL	LOMENO24	;A/B=C, zbytek je v A
	MOVF	C1,W		;uloit d 1000
	MOVWF	R4		;
HDPA1	MOVLW	0x64		;100 do B
	MOVWF	B1		;
	CLRF	B2		;
	CALL	LOMENO24	;A/B=C, zbytek je v A
	MOVF	C1,W		;uloit d 100
	MOVWF	R3		;
	MOVLW	0x0A		;10 do B
	MOVWF	B1		;
	CLRF	B2		;
	CALL	LOMENO24	;A/B=C, zbytek je v A
	MOVF	C1,W		;uloit d 10
	MOVWF	R2		;
	MOVF	A1,W		;uloit d 1
	MOVWF	R1		;

;zobrazit R1,2,3 nezobrazovat nevznamn nuly
	MOVF	R3,W
	BTFSC	SZ		;R3=0?
	MOVLW	sp		;ANO, mezera
	MOVWF	Znak1

	MOVF	R2,W
	BTFSC	SZ		;R3=0?
	MOVLW	sp		;ANO, mezera

	MOVF	R3,F
	BTFSS	SZ		;R3=0?
	MOVF	R2,W		;NE
	MOVWF	Znak2

	MOVF	R1,W
	MOVWF	Znak3

	RETURN

;--------------------------------
;zobrazit poruchu
;ZERR	MOVLW	zE		;E
;	MOVWF	Znak1
;	MOVLW	zr+.		;r.
;	MOVWF	Znak2
;	MOVF	A1,W		;slo teploty 0, 1 nebo 2
;;	ADDLW	.		;pidat teku
;	MOVWF	Znak3
;
;	RETURN


;================================
;test nco stisknuto?
TNS	CLRWDT
	CALL	MV		;nejdv men vzdlenosti
	MOVF	KLVP,W
	XORLW	B'00000111'	;st.=0
	BTFSS	SZ		;nic?
	BRA	TNS		;nco
	MOVLW	255		;16,5 sekund (1=65ms)
	MOVWF	DN		; pro mvrat na DIS1
	RETURN

;KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK
KLV	CALL	MV		;nejdv men vzdlenosti
	CLRWDT
;test KLV + opakovan, SZ=0=nco stisknuto, 1=dn tlatko
	MOVF	KLVP,W
	XORLW	B'00000111'	;(st.=0)
	BTFSS	SZ		;=1?, nenulov? (dn tlatko)
	BRA	Neco		;nco stisknuto
	BCF	Stisk		;=0
	BSF	Znova		;=1
	RETURN
Neco
	MOVLW	255		;16,5 sekund (1=65ms)
	MOVWF	DN		; pro mvrat na DIS1

	BTFSS	TlS		;stisknuto TlS?
	BRA	$+2		;ANO
	CLRF	BLIK		;NE, nulovat
	BSF	SZ		;=1
	BTFSS	Znova		;=1? odasovno?
	RETURN			;NE, jako dn tl.

	MOVLW	24		;krat as (0,1s)
	BTFSS	Stisk		;minule stisknuto?
	MOVLW	244		;del as (1s)
	MOVWF	KLVO		;nastavit asova pro opakovn
	BTFSC	TlS		;stisknuto TlS?
	BRA	$+2
	CLRF	KLVO		;ANO, MAX as
	BCF	Znova		;=0
	BSF	Stisk		;=1
	BCF	SZ		;=0
	RETURN

;EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
;ten EEPROM, adresu do EEADRp, vrt data v W
ERead	CLRWDT
	MOVLB	3
	MOVF	EEADRp,W	;Adresa
	MOVWF	EEADRL		;do ukazatele
	BCF	EECON1,CFGS	;Deselect Config space
	BCF	EECON1,EEPGD	;Point to DATA memory
	BSF	EECON1,RD	;EE Read
	MOVF	EEDATL,W	;W = EEDATL
	MOVLB	0
	RETURN

;--------------------------------
;zpis do EEPROM, adresu do EEADRp, data do W
EWrite	CLRWDT
	MOVLB	3
	MOVWF	EEDATL		;Data Memory Value to write
	MOVF	EEADRp,W	;Adresa
	MOVWF	EEADRL		;Data Memory Address to write
	BCF	EECON1,CFGS	;Deselect Configuration space
	BCF	EECON1,EEPGD	;Point to DATA memory
	BSF	EECON1,WREN	;Enable writes
	BCF	INTCON,GIE	;Disable INTs.
	MOVLW	55h		;
	MOVWF	EECON2		;Write 55h
	MOVLW	0AAh		;
	MOVWF	EECON2		;Write AAh
	BSF	EECON1,WR	;Set WR bit to begin write
	BSF	INTCON,GIE	;Enable Interrupts
	BCF	EECON1,WREN	;Disable writes
	BTFSC	EECON1,WR	;Wait for write to complete
	BRA	$-2		;Done
	MOVLB	0
	RETURN

;IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
Init
;zkladn nastaven procesoru
	MOVLB	7
	MOVLW	B'00001000'	;povolit peruen od sestupn hrany na RB3
	MOVWF	IOCBN		;
	MOVLW	B'00001000'	;povolit peruen od vzestupn hrany na RB3
	MOVWF	IOCBP		;
	MOVLB	4
	MOVLW	B'11111111'	;Pull-up na RA5
	MOVWF	WPUA		;
	MOVLW	B'00000111'	;Pull-up na RB0-RB2
	MOVWF	WPUB
	MOVLB	3
	MOVLW	B'11100000'	;0=Digt.I/O, 1=Analog vstup
	MOVWF	ANSELA		;
	MOVLW	B'00000001'	;
	MOVWF	ANSELB		;
	MOVLB	2
	MOVLW	B'01000000'	;ref.napt OFF
	MOVWF	FVRCON		;
	MOVLW	B'01011010'	;D/A OFF
	MOVWF	DACCON0		;
	MOVLW	B'11110111'	;D/A OFF
	MOVWF	DACCON1		;
	MOVLB	1
	MOVLW	B'01101111'	;vnitn osciltor 4MHz
	MOVWF	OSCCON		;
	MOVLW	B'00100000'	;PORTA, 0=vstup, 1=vstup
	MOVWF	TRISA		;
	MOVLW	B'00001000'	;PORTB, 0=vstup, 1=vstup
	MOVWF	TRISB		;
	MOVLW	B'01000011'	;peddli 1:16 pro TMR0
	MOVWF	OPTION_REG	;
	MOVLW	B'10000110'	;A/D OFF
	MOVWF	ADCON0		;
	MOVLW	B'10101000'	;vpravo, Fosc/32, Vref-:GND, Vref+:Vdd (A/A VYP)
	MOVWF	ADCON1		;
	MOVLB	0
	MOVLW	B'00101000'	;povolit peruen od TMR0 a PERIFERIE (RB3)
	MOVWF	INTCON		;
	MOVLW	B'01010100'	;nastaven TMR1 (4MHz, /2, bez synchonizace)
	MOVWF	T1CON		;

	CLRF	T2CON
	CLRF	FSR0H
;	CLRF	FSR1H
	CLRF	EEADRH
	CLRF	EEDATH

;obnoven RAM z EEPROM 0x00-0x09
	CLRF	EEADRp		;poten adresa EEPROM
	MOVLW	HM11		;poten adresa RAM
	MOVWF	FSR0L		;do ukazovtka
	CALL	ERead		;ten EEPROM
	MOVWF	INDF0		;zpis na adresu v ukazovtku
	INCF	EEADRp,F	;adresa EEPROM+1
	INCF	FSR0L,F		;ukazovtko+1
	MOVF	FSR0L,W
	SUBLW	K2		;posledn adresa RAM
	BTFSC	SC		;zporn?
	BRA	$-7		;NE

;prvn nastaven
	CLRF	DIS		;poad displej
	MOVLW	B'00000111'
	MOVWF	KLVP		;port klvesnice
	CLRF	KLVD		;dli ten klvesnice

	BCF	VA1		;VYP L1
	BCF	VB4		;VYP L2
	BCF	VA3		;VYP ERROR

;zapnout peruen
	BSF	INTCON,GIE	;od TMR0 a RB3



;-------------------------------;
;	     MENU		;
;-------------------------------;
;nadpis [cm] vzdlenost
NVZD	MOVLW	zc		;c
	MOVWF	Znak1
	MOVLW	zn		;m
	MOVWF	Znak2
	MOVLW	43		;
	MOVWF	Znak3
	CALL	TNS		;test neco stisknuto?
;zobrazit vzdlenost
ZVZD	MOVF	AV1,W
	MOVWF	A1
	MOVF	AV2,W
	MOVWF	A2
	CALL	HEXDEC		;zobrazit
;tlatka
	CALL	KLV
	BTFSC	SZ		;Z=0? neco stisknuto?
	BRA	ZVZD		;NE
	BTFSS	TlM		;stisknuto?
	GOTO	NRUP		;ANO
	BTFSS	TlP		;stisknuto?
	BRA	NHM1		;ANO
;S
	MOVLW	zc		;c
	MOVWF	Znak1
	MOVLW	zn		;m
	MOVWF	Znak2
	MOVLW	43		;
	MOVWF	Znak3
;pauza pro S
	CLRWDT
	BTFSC	TlS		;stisknuto?
	BRA	ZVZD		;NE
	BTFSS	Znova		;odcasovano?
	BRA	$-4		;NE
	BCF	Znova		;nulovat
;blikat VZD
BVZD	BTFSS	BLIK,6
	BRA	$+3
	CALL	VYPD		;VYP displej
	BRA	$+6

	MOVF	AV1,W
	MOVWF	A1
	MOVF	AV2,W
	MOVWF	A2
	CALL	HEXDEC		;zobrazit
;tlatka
	CALL	KLV
	BTFSC	SZ		;Z=0? neco stisknuto?
	BRA	BVZD		;NE
	BTFSS	TlS		;stisknuto?
	BRA	UK		;ANO
	BTFSS	TlM		;stisknuto?
	BRA	KP57		;ANO
;test K2<50
	MOVF	K2,W		;50-K2
	SUBLW	0x50
	BTFSC	SC		;zporn?
	BRA	BVZD		;NE
;K-80
	MOVLW	0x80
	SUBWF	K1,F		;K1-80
	CLRW
	SUBWFB	K2,F		;K2-0-SC
	BRA	BVZD
KP57
;test K2>A0
	MOVLW	0xA0
	SUBWF	K2,W		;K2-A0
	BTFSC	SC		;zporn?
	BRA	BVZD		;NE
;K+80
	MOVLW	0x80
	ADDWF	K1,F		;K1+80
	BTFSC	SC		;penos?
	INCF	K2,F		;ANO, K2+1
	BRA	BVZD
;uloit do EEPROM
UK	MOVLW	0x08
	MOVWF	EEADRp
	MOVF	K1,W
	CALL	EWrite
	INCF	EEADRp,F	;+1
	MOVF	K2,W
	CALL	EWrite
	BRA	NVZD

;--------------------------------
;nadpis [H.M.1] horn mez 1
NHM1	MOVLW	zH+.		;H.
	MOVWF	Znak1
	MOVLW	zM+.		;M.
	MOVWF	Znak2
	MOVLW	1		;1
	MOVWF	Znak3
	CALL	TNS		;test neco stisknuto?
;zobrazit HM1
ZHM1	MOVF	HM11,W
	MOVWF	A1
	MOVF	HM12,W
	MOVWF	A2
	CALL	HEXDEC		;zobrazit
;nvrat
	MOVF	DN,F
	BTFSC	SZ
	GOTO	ZVZD
;tlatka
	CALL	KLV
	BTFSC	SZ		;Z=0? neco stisknuto?
	BRA	$-5		;NE
	BTFSS	TlM		;stisknuto?
	BRA	NVZD		;ANO
	BTFSS	TlP		;stisknuto?
	BRA	NDM1		;ANO
;S
	MOVLW	zH+.		;H.
	MOVWF	Znak1
	MOVLW	zM+.		;M.
	MOVWF	Znak2
	MOVLW	1		;1
	MOVWF	Znak3
;pauza pro S
	CLRWDT
	BTFSC	TlS		;stisknuto?
	BRA	ZHM1		;NE
	BTFSS	Znova		;odcasovano?
	BRA	$-4		;NE
	BCF	Znova		;nulovat
;blikat HM1
BHM1	BTFSS	BLIK,6
	BRA	$+3
	CALL	VYPD		;VYP displej
	BRA	$+6

	MOVF	HM11,W		;ZAP
	MOVWF	A1		; displej
	MOVF	HM12,W		;
	MOVWF	A2		;
	CALL	HEXDEC		;zobrazit
;tlatka
	CALL	KLV
	BTFSC	SZ		;Z=0? neco stisknuto?
	BRA	BHM1		;NE
	BTFSS	TlS		;stisknuto?
	BRA	UHM1		;ANO
	BTFSS	TlP		;stisknuto?
	BRA	HM1P1		;ANO
;horn mez1 -1
HM1M1	MOVF	HM11,W
	MOVWF	A1
	MOVF	HM12,W
	MOVWF	A2
	CALL	MEZM		;mez-1
	MOVF	A1,W
	MOVWF	HM11
	MOVF	A2,W
	MOVWF	HM12
	BRA	BHM1
;horn mez1 +1
HM1P1	MOVF	HM11,W
	MOVWF	A1
	MOVF	HM12,W
	MOVWF	A2
	CALL	MEZP		;mez+1
	MOVF	A1,W
	MOVWF	HM11
	MOVF	A2,W
	MOVWF	HM12
	BRA	BHM1
;uloit do EEPROM
UHM1	MOVLW	0x00
	MOVWF	EEADRp
	MOVF	HM11,W
	CALL	EWrite
	INCF	EEADRp,F	;+1
	MOVF	HM12,W
	CALL	EWrite
	BRA	NHM1

;--------------------------------
;nadpis [d.M.1] doln mez 1
NDM1	MOVLW	zd+.		;d.
	MOVWF	Znak1
	MOVLW	zM+.		;M.
	MOVWF	Znak2
	MOVLW	1		;1
	MOVWF	Znak3
	CALL	TNS		;test neco stisknuto?
;zobrazit DM1
ZDM1	MOVF	DM11,W
	MOVWF	A1
	MOVF	DM12,W
	MOVWF	A2
	CALL	HEXDEC		;zobrazit
;nvrat
	MOVF	DN,F
	BTFSC	SZ
	GOTO	ZVZD
;tlatka
	CALL	KLV
	BTFSC	SZ		;Z=0? neco stisknuto?
	BRA	$-5		;NE
	BTFSS	TlM		;stisknuto?
	BRA	NHM1		;ANO
	BTFSS	TlP		;stisknuto?
	BRA	NHM2		;ANO
;S
	MOVLW	zd+.		;d.
	MOVWF	Znak1
	MOVLW	zM+.		;M.
	MOVWF	Znak2
	MOVLW	1		;1
	MOVWF	Znak3
;pauza pro S
	CLRWDT
	BTFSC	TlS		;stisknuto?
	BRA	ZDM1		;NE
	BTFSS	Znova		;odcasovano?
	BRA	$-4		;NE
	BCF	Znova		;nulovat
;blikat DM1
BDM1	BTFSS	BLIK,6
	BRA	$+3
	CALL	VYPD		;VYP displej
	BRA	$+6

	MOVF	DM11,W		;ZAP
	MOVWF	A1		; displej
	MOVF	DM12,W		;
	MOVWF	A2		;
	CALL	HEXDEC		;zobrazit
;tlatka
	CALL	KLV
	BTFSC	SZ		;Z=0? neco stisknuto?
	BRA	BDM1		;NE
	BTFSS	TlS		;stisknuto?
	BRA	UDM1		;ANO
	BTFSS	TlP		;stisknuto?
	BRA	DM1P1		;ANO
;doln mez1 -1
DM1M1	MOVF	DM11,W
	MOVWF	A1
	MOVF	DM12,W
	MOVWF	A2
	CALL	MEZM		;mez-1
	MOVF	A1,W
	MOVWF	DM11
	MOVF	A2,W
	MOVWF	DM12
	BRA	BDM1
;doln mez1 +1
DM1P1	MOVF	DM11,W
	MOVWF	A1
	MOVF	DM12,W
	MOVWF	A2
	CALL	MEZP		;mez+1
	MOVF	A1,W
	MOVWF	DM11
	MOVF	A2,W
	MOVWF	DM12
	BRA	BDM1
;uloit do EEPROM
UDM1	MOVLW	0x02
	MOVWF	EEADRp
	MOVF	DM11,W
	CALL	EWrite
	INCF	EEADRp,F	;+1
	MOVF	DM12,W
	CALL	EWrite
	BRA	NDM1

;--------------------------------
;nadpis [H.M.2] horn mez 2
NHM2	MOVLW	zH+.		;H.
	MOVWF	Znak1
	MOVLW	zM+.		;M.
	MOVWF	Znak2
	MOVLW	2		;2
	MOVWF	Znak3
	CALL	TNS		;test neco stisknuto?
;zobrazit HM2
ZHM2	MOVF	HM21,W
	MOVWF	A1
	MOVF	HM22,W
	MOVWF	A2
	CALL	HEXDEC		;zobrazit
;nvrat
	MOVF	DN,F
	BTFSC	SZ
	GOTO	ZVZD
;tlatka
	CALL	KLV
	BTFSC	SZ		;Z=0? neco stisknuto?
	BRA	$-5		;NE
	BTFSS	TlM		;stisknuto?
	BRA	NDM1		;ANO
	BTFSS	TlP		;stisknuto?
	BRA	NDM2		;ANO
;S
	MOVLW	zH+.		;H.
	MOVWF	Znak1
	MOVLW	zM+.		;M.
	MOVWF	Znak2
	MOVLW	2		;2
	MOVWF	Znak3
;pauza pro S
	CLRWDT
	BTFSC	TlS		;stisknuto?
	BRA	ZHM2		;NE
	BTFSS	Znova		;odcasovano?
	BRA	$-4		;NE
	BCF	Znova		;nulovat
;blikat HM2
BHM2	BTFSS	BLIK,6
	BRA	$+3
	CALL	VYPD		;VYP displej
	BRA	$+6

	MOVF	HM21,W		;ZAP
	MOVWF	A1		; displej
	MOVF	HM22,W		;
	MOVWF	A2		;
	CALL	HEXDEC		;zobrazit
;tlatka
	CALL	KLV
	BTFSC	SZ		;Z=0? neco stisknuto?
	BRA	BHM2		;NE
	BTFSS	TlS		;stisknuto?
	BRA	UHM2		;ANO
	BTFSS	TlP		;stisknuto?
	BRA	HM2P1		;ANO
;horn mez2 -1
HM2M1	MOVF	HM21,W
	MOVWF	A1
	MOVF	HM22,W
	MOVWF	A2
	CALL	MEZM		;mez-1
	MOVF	A1,W
	MOVWF	HM21
	MOVF	A2,W
	MOVWF	HM22
	BRA	BHM2
;horn mez2 +1
HM2P1	MOVF	HM21,W
	MOVWF	A1
	MOVF	HM22,W
	MOVWF	A2
	CALL	MEZP		;mez+1
	MOVF	A1,W
	MOVWF	HM21
	MOVF	A2,W
	MOVWF	HM22
	BRA	BHM2
;uloit do EEPROM
UHM2	MOVLW	0x04
	MOVWF	EEADRp
	MOVF	HM21,W
	CALL	EWrite
	INCF	EEADRp,F	;+1
	MOVF	HM22,W
	CALL	EWrite
	BRA	NHM2

;--------------------------------
;nadpis [d.M.2] doln mez 2
NDM2	MOVLW	zd+.		;d.
	MOVWF	Znak1
	MOVLW	zM+.		;M.
	MOVWF	Znak2
	MOVLW	2		;2
	MOVWF	Znak3
	CALL	TNS		;test neco stisknuto?
;zobrazit DM2
ZDM2	MOVF	DM21,W
	MOVWF	A1
	MOVF	DM22,W
	MOVWF	A2
	CALL	HEXDEC		;zobrazi
;nvrat
	MOVF	DN,F
	BTFSC	SZ
	GOTO	ZVZD
;tlatka
	CALL	KLV
	BTFSC	SZ		;Z=0? neco stisknuto?
	BRA	$-5		;NE
	BTFSS	TlM		;stisknuto?
	BRA	NHM2		;ANO
	BTFSS	TlP		;stisknuto?
	BRA	NRUP		;ANO
;S
	MOVLW	zd+.		;d.
	MOVWF	Znak1
	MOVLW	zM+.		;M.
	MOVWF	Znak2
	MOVLW	2		;2
	MOVWF	Znak3
;pauza pro S
	CLRWDT
	BTFSC	TlS		;stisknuto?
	BRA	ZDM2		;NE
	BTFSS	Znova		;odcasovano?
	BRA	$-4		;NE
	BCF	Znova		;nulovat
;blikat DM2
BDM2	BTFSS	BLIK,6
	BRA	$+3
	CALL	VYPD		;VYP displej
	BRA	$+6

	MOVF	DM21,W		;ZAP
	MOVWF	A1		; displej
	MOVF	DM22,W		;
	MOVWF	A2		;
	CALL	HEXDEC		;zobrazit
;tlatka
	CALL	KLV
	BTFSC	SZ		;Z=0? neco stisknuto?
	BRA	BDM2		;NE
	BTFSS	TlS		;stisknuto?
	BRA	UDM2		;ANO
	BTFSS	TlP		;stisknuto?
	BRA	DM2P1		;ANO
;doln mez2 -1
DM2M1	MOVF	DM21,W
	MOVWF	A1
	MOVF	DM22,W
	MOVWF	A2
	CALL	MEZM		;mez-1
	MOVF	A1,W
	MOVWF	DM21
	MOVF	A2,W
	MOVWF	DM22
	BRA	BDM2
;doln mez2 +1
DM2P1	MOVF	DM21,W
	MOVWF	A1
	MOVF	DM22,W
	MOVWF	A2
	CALL	MEZP		;mez+1
	MOVF	A1,W
	MOVWF	DM21
	MOVF	A2,W
	MOVWF	DM22
	BRA	BDM2
;uloit do EEPROM
UDM2	MOVLW	0x06
	MOVWF	EEADRp
	MOVF	DM21,W
	CALL	EWrite
	INCF	EEADRp,F	;+1
	MOVF	DM22,W
	CALL	EWrite
	BRA	NDM2

;--------------------------------
;nadpis [ru.P.] run provoz
NRUP	MOVLW	zr		;r
	MOVWF	Znak1
	MOVLW	zu+.		;u.
	MOVWF	Znak2
	MOVLW	zP+.		;P.
	MOVWF	Znak3
	CALL	TNS		;test neco stisknuto?
	MOVLW	zr+.		;r.
	MOVWF	Znak1
;zobrazit, stavy vstup
ZRUP	MOVLW	1
	BTFSS	VB4
	CLRW
	MOVWF	Znak2
	MOVLW	1
	BTFSS	VA1
	CLRW
	MOVWF	Znak3
;nvrat
	MOVF	DN,F
	BTFSC	SZ
	GOTO	ZVZD
;tlatka
	CALL	KLV
	BTFSC	SZ		;neco stisknuto?
	BRA	ZRUP		;nic
	BTFSS	TlM		;stisknuto?
	BRA	NDM2		;ANO
	BTFSS	TlP		;stisknuto?
	GOTO	NVZD		;ANO
;stisknuto S
	MOVLW	zr		;r
	MOVWF	Znak1
	MOVLW	zu+.		;u.
	MOVWF	Znak2
	MOVLW	zP+.		;P.
	MOVWF	Znak3
;pauza pro S
	CLRWDT
	BTFSC	TlS		;stisknuto?
	BRA	ZRUP-2		;NE
	BTFSS	Znova		;odasovno?
	BRA	$-4		;NE
	BCF	Znova
	MOVLW	zr+.		;r.
	MOVWF	Znak1

;blikat, stavy vstup
BRUP	BTFSS	BLIK,6
	BRA	$+5

	MOVLW	sp		;VYP
	MOVWF	Znak2		; displej
	MOVWF	Znak3		;
	BRA	$+9

	MOVLW	1		;ZAP
	BTFSS	VB4		; displej
	CLRW
	MOVWF	Znak2
	MOVLW	1
	BTFSS	VA1
	CLRW
	MOVWF	Znak3
;tlatka
	CALL	KLV+1		;bez men teploty
	BTFSC	SZ		;Z=0? neco stisknuto
	BRA	BRUP		;nic
	BTFSS	TlS		;stisknuto?
	BRA	NRUP		;ANO
	BTFSS	TlP		;stisknuto?
	BRA	VA1ZV		;ANO
;VB4 ZAP/VYP
VB4ZV	BTFSS	VB4
	BRA	$+3
	BCF	VB4		;0 VYP
	BRA	BRUP
	BSF	VB4		;1 ZAP
	BRA	BRUP
;VA1 ZAP/VYP
VA1ZV	BTFSS	VA1
	BRA	$+3
	BCF	VA1		;0 VYP
	BRA	BRUP
	BSF	VA1		;1 ZAP
	BRA	BRUP

;================================
;vzdlenost A do A
V_A	MOVF	AV1,W
	MOVWF	A1
	MOVF	AV2,W
WA2	MOVWF	A2
	RETURN
;--------------------------------
;vzdlenost A do B
V_B	MOVF	AV1,W
	MOVWF	B1
	MOVF	AV2,W
WB2	MOVWF	B2	
	RETURN
;--------------------------------
;horn mez 1 do A
H1_A	MOVF	HM11,W
	MOVWF	A1
	MOVF	HM12,W
	BRA	WA2
;--------------------------------
;horn mez 2 do A
H2_A	MOVF	HM21,W
	MOVWF	A1
	MOVF	HM22,W
	BRA	WA2
;--------------------------------
;doln mez 1 do B
D1_B	MOVF	DM11,W
	MOVWF	B1
	MOVF	DM12,W
	BRA	WB2
;--------------------------------
;doln mez 2 do B
D2_B	MOVF	DM21,W
	MOVWF	B1
	MOVF	DM22,W
	BRA	WB2
;--------------------------------
;Porovnat hodnoty A a B
;A <= B  SC=0			;vsledek ovlivn STATUS,C
;B => A  SC=0			;
;A > B   SC=1			;
;B < A   SC=1			;
PAB
;porovnat znamnka
	MOVF	A2,W
	XORWF	B2,W		;(stejn=0)
	ANDLW	B'10000000'	;(1a1=1)
	RLF	B2,W		;vlevo(SC=MSB)
	BTFSS	SZ		;stejn znamnka? (SZ=1)
	RETURN			;NE
;A-B				;ANO
	CLRF	A3
	CLRF	B3
	CALL	MINUS		;A-B=C; SC=0=zporn vsledek
;test C=0; SZ=1=ANO
	MOVF	C3,F
	BTFSC	SZ		;nenulove?
	MOVF	C2,F
	BTFSC	SZ		;nenulove?
	MOVF	C1,F
	BTFSC	SZ		;nenulov?
	BCF	SC		;SC=0 (A=B) jako zporn
	RETURN

;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO;
OV;	ovldn vstup	;
;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO;

;VB4=0 pi V => HM1
;V => HM1
	CALL	V_B
	CALL	H1_A
	CALL	PAB		;porovnat B => A ; SC=0=ANO, 1=NE
	BTFSS	SC		;ANO?
	BCF	VB4		;=0, VYP

;VB4=1 pi V <= DM1
;V <= DM1
	CALL	V_A		;V do A
	CALL	D1_B		;DM1 do B
	CALL	PAB		;porovnat A <= B ; SC=0=ANO, 1=NE
	BTFSS	SC		;ANO?
	BSF	VB4		;=1, ZAP
	
;VA1=1 pi V => HM2
;V => HM2
	CALL	V_B
	CALL	H2_A
	CALL	PAB		;porovnat B => A ; SC=0=ANO, 1=NE
	BTFSS	SC		;ANO?
	BSF	VA1		;=1, VYP

;VA1=0 pi V <= DM2
;V <= DM2
	CALL	V_A		;V do A
	CALL	D2_B		;DM2 do B
	CALL	PAB		;porovnat A <= B ; SC=0=ANO, 1=NE
	BTFSS	SC		;ANO?
	BCF	VA1		;=0, ZAP

	RETURN

;--------------------------------
	END
